package common.pathfinding;

import common.init.Blocks;
import common.util.BlockPos;
import common.world.Chunk;
import common.world.ChunkCache;
import common.world.IBlockAccess;
import common.world.State;
import common.world.World;

public class PathCache extends ChunkCache implements IBlockAccess
{
    public PathCache(World worldIn, BlockPos posFromIn, BlockPos posToIn)
    {
        super(worldIn, posFromIn, posToIn, 0);
    }

    public State getState(BlockPos pos)
    {
        int i = (pos.getX() >> 4) - this.chunkX;
        int n = (pos.getY() >> 4) - this.chunkY;
        int j = (pos.getZ() >> 4) - this.chunkZ;

        if (i >= 0 && i < this.chunkArray.length && n >= 0 && n < this.chunkArray[i].length && j >= 0 && j < this.chunkArray[i][n].length)
        {
            Chunk chunk = this.chunkArray[i][n][j];

            if (chunk != null)
            {
                return chunk.getState(pos);
            }
        }

        return Blocks.air.getState();
    }
}
