package common.world;

import common.util.BlockPos;

public class ChunkCache
{
    protected final int chunkX;
    protected final int chunkY;
    protected final int chunkZ;
    protected final Chunk[][][] chunkArray;

    public ChunkCache(World worldIn, BlockPos posFromIn, BlockPos posToIn, int subIn)
    {
        this.chunkX = posFromIn.getX() - subIn >> 4;
        this.chunkY = posFromIn.getY() - subIn >> 4;
        this.chunkZ = posFromIn.getZ() - subIn >> 4;
        int i = posToIn.getX() + subIn >> 4;
        int n = posToIn.getY() + subIn >> 4;
        int j = posToIn.getZ() + subIn >> 4;
        this.chunkArray = new Chunk[i - this.chunkX + 1][n - this.chunkY + 1][j - this.chunkZ + 1];

        for (int k = this.chunkX; k <= i; ++k)
        {
            for (int m = this.chunkY; m <= n; ++m)
            {
	            for (int l = this.chunkZ; l <= j; ++l)
	            {
	                this.chunkArray[k - this.chunkX][m - this.chunkY][l - this.chunkZ] = worldIn.getChunk(k, l);
	            }
            }
        }
    }
}
