package server.worldgen;

import common.init.BlockRegistry;
import common.init.Blocks;
import common.world.State;

public class ChunkPrimer {
	private final short[] data;
	
	public ChunkPrimer() {
		this.data = new short[4096];
	}
	
	public short[] getData() {
		return this.data;
	}

	public State get(int x, int y, int z) {
		State state = BlockRegistry.STATEMAP.getByValue(this.data[x << 4 | z | y << 8]);
		return state != null ? state : Blocks.air.getState();
	}

	public void set(int x, int y, int z, State state) {
		this.data[x << 4 | z | y << 8] = (short)BlockRegistry.STATEMAP.get(state);
	}
}
